package extensions;

import java.io.IOException;

import java.net.Socket;

import java.util.regex.Matcher;
import java.util.regex.Pattern;

import dareka.common.Logger;
import dareka.extensions.Extension;
import dareka.extensions.RequestFilter;
import dareka.extensions.Extension2;
import dareka.extensions.ExtensionManager;
import dareka.processor.HttpHeader;
import dareka.processor.HttpRequestHeader;
import dareka.processor.Resource;
import dareka.processor.StringResource;
import dareka.processor.Processor;
import dareka.processor.impl.Cache;

/*
 *
 */
public class liveInfoExtension implements Extension, Extension2, Processor, RequestFilter {

	// Extension interface
	public Object queryInterface(Extension.Type type) {
		if (type == Extension.Type.Extension1)
			return (Extension) this;
		if (type == Extension.Type.Processor1)
			return (Processor) this;
		if (type == Extension.Type.RequestFilter1)
			return (RequestFilter) this;
		return null;
	}

	public void registerExtensions(ExtensionManager mgr) {
		mgr.registerProcessor(this);
		mgr.registerRequestFilter(this);
	}

	public String getVersionString() {
		return "liveInfoExtension (9).01";
	}

	public liveInfoExtension() throws IOException {
	}

    private static final String[] PROCESSOR_SUPPORTED_METHODS =
        new String[] { "GET" };

	public String[] getSupportedMethods() {
	    return PROCESSOR_SUPPORTED_METHODS;
	}

    private static final Pattern PROCESSOR_SUPPORTED_PATTERN = Pattern.compile(
			"^http://live\\.nicovideo\\.jp/cache/liveinfo");

    private static final Pattern LIVE_CKEY_PATTERN = Pattern.compile(
			"^http://.*\\.live\\.nicovideo\\.jp/api/getckey\\?.*[&?]id=(\\w{2}\\d+)");

	public Pattern getSupportedURLAsPattern() {
		return PROCESSOR_SUPPORTED_PATTERN;
	}

	public String getSupportedURLAsString() {
		return null;
	}

	private static String[] idList = { "", "" };
	private static String[] idListIsCache = { "none", "none" };

	public int onRequest(HttpRequestHeader requestHeader) throws IOException {
		String uri = requestHeader.getURI();
		Matcher m = LIVE_CKEY_PATTERN.matcher(uri);
		if (m.find()) {
			idList[1] = idList[0];
			idList[0] = m.group(1);
			idListIsCache[1] = idListIsCache[0];
			String isCache = Cache.getType(idList[0]);
			if (isCache != null) {
				if (isCache.equals("")) {
					idListIsCache[0] = "cache";
				} else {
					idListIsCache[0] = "low";
				}
			} else {
				idListIsCache[0] = "none";
			}
		}
		return RequestFilter.OK;
	}

	public Resource onRequest(HttpRequestHeader requestHeader, Socket browser)
			throws IOException {
		String str = idList[0]+","+idListIsCache[0]+","+idList[1]+","+idListIsCache[1];
		StringResource r = new StringResource(str);
		r.addNoCacheResponseHeaders();
		r.addResponseHeader(HttpHeader.CONTENT_TYPE, "text/plain");
		return r;
	}

}


