// liveinfo.js
// 10/01/20 v0.2


(function() {
// 表示する動画情報の最大数
	var listNum = 3;

	var id = new Array(listNum);
	var title = new Array(listNum);
	var count = new Array(listNum);
	var comment = new Array(listNum);
	var mylist = new Array(listNum);
	var length = new Array(listNum);
	var desc = new Array(listNum);
	var isCache = new Array(listNum);
	var mylist_flag = new Array(listNum);
	var holder = 0;

// メイン関数。これ呼べばデータ取得･アップデート
// Extensionから動画リスト取得して処理にまわす
	function getLiveList() {
		var url="http://live.nicovideo.jp/cache/liveinfo";
		new Ajax.Request(
			url,
			{
				method: 'get',
				onSuccess: getLiveListResponce
			}
		);
	}
// リストが更新されてたらデータ取得とか表示更新とか
	function getLiveListResponce(httpObj) {
		if (httpObj.responseText != "") {
			var list = httpObj.responseText.split(",");
			if (list[0] == "" || list[0] == id[holder]) return;
			holder = (holder+1)%listNum;
			id[holder] = list[0];
			isCache[holder] = list[1];
			title[holder] = undefined;
			getData();
		}
	}
// thumbinfoからデータ取得
	function getData() {
		new Ajax.Request("http://live.nicovideo.jp/api/getthumbinfo/"+id[holder], {
			method: "get",
			onSuccess: getDataResponse
		});
	}
	function getDataResponse(httpObj) {
		title[holder] = "unknown";
		count[holder] = "";
		comment[holder] = "";
		mylist[holder] = "";
		length[holder] = "";
		desc[holder] = "";
		mylist_flag[holder] = -1;
		var tagtext = "";
		var m = httpObj.responseText.match(/<title>(.+)<\/title>/);
		if (m) title[holder] = m[1].replace(/&apos;/g,"'").replace(/&amp;/g,"&").replace(/&nbsp;/g,"");
		m = httpObj.responseText.match(/<view_counter>(.+)<\/view_counter>/);
		if (m) count[holder] = m[1];
		m = httpObj.responseText.match(/<comment_num>(.+)<\/comment_num>/);
		if (m) comment[holder] = m[1];
		m = httpObj.responseText.match(/<mylist_counter>(.+)<\/mylist_counter>/);
		if (m) mylist[holder] = m[1];
		m = httpObj.responseText.match(/<length>(.+)<\/length>/);
		if (m) length[holder] = m[1];
		m = httpObj.responseText.match(/<description>([\s\S]+)<\/description>/);
		if (m) desc[holder] = m[1].replace(/&apos;/g,"'").replace(/&amp;/g,"&").replace(/&nbsp;/g,"");
		m = httpObj.responseText.match(/<tags domain="jp">([\s\S]+?)<\/tags>/);
		if (m) tagtext = "<br><span style='color:blue;'>"+(m[1].replace(/<tag[^>]*>/g,"　").replace(/<\/tag>/g,""))+"</span>";
		desc[holder] += tagtext;

		updateView();
	}
// 表示を更新する
	function updateView() {
		var infoList = $("nl_liveInfoList");
		var str = '';
		for (var i=listNum; i>0; i--) {
			if (title[(holder+i)%listNum]) str += getInfoLine((holder+i)%listNum);
		}
		infoList.innerHTML = str;
	}
// movieFetcherとかマイリス登録後の処理とかも埋め込む
	function getInfoLine(holder_id) {
		var str = '<table style="width:100%;"><tr><td width="13%">'+
		id[holder_id];
		if (nicofetch && isCache[holder_id] != "cache") {
			str += '<a href="javascript:void(0)" onclick="nicofetch(this,\''+id[holder_id]+'\',0)" style="font-size:10px;">(fetch)</a>';
		}
		str += '</td><td>'+
			'<a href="http://www.nicovideo.jp/watch/'+id[holder_id]+'" target="_blank" onmouseover="$(\'nl_'+id[holder_id]+'\').style.display=\'\'" onmouseout="$(\'nl_'+id[holder_id]+'\').style.display=\'none\'"';
		if (isCache[holder_id] == "cache") {
			str += ' style="color:#C00000"';
		} else if (isCache[holder_id] == "low") {
			str += ' style="color:#C08000"';
		}
		str += '>'+title[holder_id]+'</a></td>'+
			'<td width="3%">再生</td><td width="7%">'+count[holder_id]+'</td>';
		if (mylist_flag[holder_id] < 0) {
			str += '<td width="5%"><a href="javascript:void(0)" onclick="addmylist(\''+id[holder_id]+'\'); return false;">登録</a></td>'
		} else if (mylist_flag[holder_id] == 2) {
			str += '<td width="5%">登録(失)</td>';
		} else {
			str += '<td width="5%">登録(済)</td>';
		}
		str += '<td width="7%">'+mylist[holder_id]+'</td>'+
			'<td width="3%">コメ</td><td width="7%">'+comment[holder_id]+'</td>'+
			'<td width="3%">長さ</td><td width="7%">'+length[holder_id]+'</td></tr></table>';
// 動画説明文
		str+='<div id="nl_'+id[holder_id]+'" style="width:920px; position:absolute; background-color:#ffffd0; border:1px solid gray; display:none;">'+desc[holder_id]+'</div>';
		return str;
	}
// マイリスト追加処理をhookして、thread_idが無いときはgetflvから取得
	function addMylist_new(smid,thread_id) {
		if (!thread_id) {
			new Ajax.Request("http://live.nicovideo.jp/api/getflv/"+smid, {
				method: "get",
				asynchronous: false,
				onSuccess: function(httpObj) {
					var res = httpObj.responseText;
					var m = res.match(/thread_id=(\d+)&/);
					if (m) thread_id=m[1];
				}
			});
		}
		if (thread_id) {
			for (var i=0; i<listNum; i++) {
				if (smid == id[(holder+i)%listNum]){
					mylist_flag[(holder+i)%listNum] = 0;
					break;
				}
			}
			addMylist_cap(smid,thread_id);
		}
	}
// 追加後の処理もhookして、表示を更新する
	var addMylistResult_new = function(httpObj) {
		var m = httpObj.responseText.match(/status="ok"/);
		var result = 1;
		if (!m) result = 2;
		for (var i=0; i<listNum; i++) {
			if (mylist_flag[(holder+i)%listNum] == 0){
				mylist_flag[(holder+i)%listNum] = result;
				break;
			}
		}
		addMylistResult_cap(httpObj);
		updateView();
	}


// ここでマイリス関係のfunctionをhook
	var addMylist_cap = addmylist;
	addmylist = addMylist_new;
	var addMylistResult_cap = addmylistResult;
	addmylistResult = addMylistResult_new;
// 2秒ごとにリストを取得、更新されてたらページ書き換えとか
	var handle = setInterval(getLiveList, 2000);
})()
